REM http://delta.affinix.com/download/qca/2.0/qca-2.1.0.tar.gz

set P=qca-qt5
set V=2.1.0
set B=1

if "%OSGEO4W_REP%"=="" (
	echo no repository
	exit 1
)

if "%ARCH%"=="x86" (
	set OSGEO4W_ROOT=C:\OSGeo4W
	set VCARCH=x86
	set CMAKE_GEN=Visual Studio 14 2015
) else if "%ARCH%"=="x86_64" (
	set OSGEO4W_ROOT=C:\OSGeo4W64
	set VCARCH=amd64
	set CMAKE_GEN=Visual Studio 14 2015 Win64
) else (
	echo invalid arch
	exit
)

set R=%OSGEO4W_REP%\%ARCH%\release\qt5\%P%
for %%i in (devel libs) do (
	if not exist %R%\%P%-%%i mkdir %R%\%P%-%%i
	copy %%i.hint %R%\%P%-%%i\setup.hint
	copy ..\COPYING %R%\%P%-%%i\%P%-%%i-%V%-%B%.txt
)

call "%OSGEO4W_ROOT%\bin\o4w_env.bat"
call "%OSGEO4W_ROOT%\bin\qt5_env.bat"
call "c:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" %VCARCH%
path %PATH%;c:\cygwin\bin;C:\Program Files\CMake\bin
echo on

set BUILDDIR=%CD%\build-%ARCH%
if not exist %BUILDDIR% mkdir %BUILDDIR%
set INSTDIR=%OSGEO4W_ROOT%
if not exist %INSTDIR% mkdir %INSTDIR%

cd %BUILDDIR%

set LIB=%LIB%;%OSGEO4W_ROOT%\lib
set INCLUDE=%INCLUDE%;%OSGEO4W_ROOT%\include

set BUILDCONF=RelWithDebInfo

cmake -G "%CMAKE_GEN%" ^
	-DCMAKE_CONFIGURATION_TYPES=%BUILDCONF% ^
	-DQCA_PREFIX_INSTALL_DIR=%INSTDIR%/apps/Qt5 ^
	-DQCA_PLUGINS_INSTALL_DIR=%INSTDIR%/apps/Qt5/plugins/ ^
	-DQCA_BINARY_INSTALL_DIR=%INSTDIR%/apps/Qt5/bin ^
	-DQCA_LIBRARY_INSTALL_DIR=%INSTDIR%/apps/Qt5/lib ^
	-DQCA_FEATURE_INSTALL_DIR=%INSTDIR%/apps/Qt5/mkspecs/features/ ^
	-DQCA_INCLUDE_INSTALL_DIR=%INSTDIR%/apps/Qt5/include ^
	-DQCA_PRIVATE_INCLUDE_INSTALL_DIR=%INSTDIR%/apps/Qt5/include ^
	-DQCA_DOC_INSTALL_DIR=%INSTDIR%/apps/Qt5/doc/html/qca ^
	-DQCA_MAN_INSTALL_DIR=%INSTDIR%/apps/Qt5/man/ ^
-	-DQCA_SUFFIX=qt5 ^
	-DPKGCONFIG_INSTALL_PREFIX=%INSTDIR%/apps/Qt5/lib/pkgconfig ^
        ..\..
if errorlevel 1 goto error

for %%i in (ZERO_CHECK ALL_BUILD INSTALL) do (
	echo %%i: %DATE% %TIME%
	cmake --build . --target %%i --config %BUILDCONF%
	if errorlevel 1 (echo %%i error & goto error)
)

cd ..

tar -C %OSGEO4W_ROOT% -cvjf %R%\%P%-devel\%P%-devel-%V%-%B%.tar.bz2 ^
	apps/Qt5/include/QtCrypto ^
	apps/Qt5/lib/qca-qt5.lib ^
	apps/Qt5/bin/qca-qt5.pdb ^
	apps/Qt5/bin/mozcerts-qt5.pdb ^
	apps/Qt5/bin/qcatool-qt5.pdb ^
	apps/Qt5/mkspecs/features/crypto.prf ^
	apps/Qt5/lib/cmake/Qca/ ^
	apps/Qt5/plugins/crypto/qca-gnupg.pdb ^
	apps/Qt5/plugins/crypto/qca-logger.pdb ^
	apps/Qt5/plugins/crypto/qca-ossl.pdb ^
	apps/Qt5/plugins/crypto/qca-softstore.pdb
if errorlevel 1 goto error

tar -C %OSGEO4W_ROOT% -cvjf %R%\%P%-libs\%P%-libs-%V%-%B%.tar.bz2 ^
	apps/Qt5/certs/rootcerts.pem ^
	apps/Qt5/bin/qca-qt5.dll ^
	apps/Qt5/bin/mozcerts-qt5.exe ^
	apps/Qt5/bin/qcatool-qt5.exe ^
	apps/Qt5/plugins/crypto/qca-gnupg.dll ^
	apps/Qt5/plugins/crypto/qca-logger.dll ^
	apps/Qt5/plugins/crypto/qca-ossl.dll ^
	apps/Qt5/plugins/crypto/qca-softstore.dll ^
	apps/Qt5/man/man1/qcatool-qt5.1
if errorlevel 1 goto error

tar -C .. -cvjf %R%\%P%-libs\%P%-libs-%V%-%B%-src.tar.bz2 ^
	osgeo4w/package.cmd ^
	osgeo4w/libs.hint ^
	osgeo4w/devel.hint
if errorlevel 1 goto error

:error
